<template>
  <div>

    <single-pane capt="obModal">
      <ob-button @click="openModal" label="Open small modal"></ob-button>
      <ob-button @click="openModalMd" label="Open medium modal"></ob-button>
      <ob-modal
              ref="modalWindow"
              title="ob-modal small"
              size="small"
              :is-center="false"
              :is-show-controls="true">
        small ObModal window with controls
      </ob-modal>
      <ob-modal
              ref="modalWindowMd"
              title="ob-modal medium"
              size="md"
              :is-center="false"
              :is-show-controls="false">
        medium ObModal window without controls
      </ob-modal>

    </single-pane>

    <single-pane capt="Заголовок панели №1">
      Контент панели №1 - панель без ссылки назад
    </single-pane>

    <single-pane
            capt="Заголовок панели №2"
            :noUrlbacklink="true"
    >
      Контент панели №2 - панель со ссылкой назад
    </single-pane>

    <single-pane
            capt="Заголовок панели №3"
            :backlink="backLinkObject"
    >
      Контент панели №3 - кнопка "Назад" указана явно, переходит на главную страницу
    </single-pane>

    <single-pane capt="DataGrid + popup">
      <ob-table
        :items="gridDataSource"
        :columns="columnsObTable"
        :selected="selectedRow"
        :functionalPanel="false"
        :page-limit="6"
        @select="onSelection"
      />
      <ObModal
        ref="viewItem"
        title="Просмотр записи из таблицы"
        :data-grid="$refs.dataGrid"
        :is-show-pagination="true"
        size="md"
      >
        {{selectedData}}
      </ObModal>
    </single-pane>

    <single-pane capt="DataGrid + add button">
      <ob-table
        show-add-button="true"
        :items="gridDataSource"
        :columns="columnsObTable"
        :selected="selectedRow"
        :functionalPanel="false"
        :page-limit="6"
        @add="onAdd"
      />
    </single-pane>

    <single-pane capt="ObFunctionalPanel">
      <ob-functional-panel
              :columns="columns"
      />
    <ob-functional-panel
      :columns="columns"
      :show-filter="false"
    />
    </single-pane>

    <single-pane capt="ObTable">
      <ob-table
        :items="gridDataSource"
        :columns="columnsObTable"
        :selected="selectedRow"
        :functionalPanel="false"
        @select="onSelect"
        :page-limit="6"
      />
    </single-pane>

    <single-pane capt="ObTable + Panel">
      <ob-table
              :items="gridDataSource"
              :columns="columnsObTable"
              :selected="selectedRow"
              :functionalPanel="true"
              @select="onSelect"
              :page-limit="6"
      />
    </single-pane>

    <two-panes
            left-caption="Левая колонка"
            right-caption="Правка колонка"
    >
      <template slot="left">
        Контент левой колонки
      </template>
      <template slot="right">
        Контент правой колонки
      </template>
    </two-panes>

    <two-panes
            left-caption="Левая колонка + назад"
            right-caption="Правка колонка"
            :backlink="backLinkObject"
    >
      <template slot="left">
        Контент левой колонки со ссылкой назад, ведущей на главную страницу
      </template>
      <template slot="right">
        Контент правой колонки
      </template>
    </two-panes>

    <single-pane capt="ObTextarea">
      <ob-textarea
              label="ObTextarea label"
              placeholder="ObTextarea placeolder"
              :disabled="false"
      />
      <ob-textarea
              label="ObTextarea label invalid"
              placeholder="ObTextarea placeolder invalid"
              :invalid="true"
      />
      <ob-textarea
              label="ObTextarea label disabled"
              placeholder="ObTextarea placeolder disabled"
              :disabled="true"
      />
      <ob-textarea
              label="ObTextarea label readonly"
              placeholder="ObTextarea placeolder readonly"
              :readonly="true"
      />
    </single-pane>

    <single-pane capt="ObInput">
      <ob-input
              label="ObInput label"
              placeholder="ObInput placeholder"
              :disabled="false"
      ></ob-input>
      <ob-input
              label="ObInput label disabled"
              placeholder="ObInput placeholder"
              :disabled="true"
      ></ob-input>
      <ob-input
              label="ObInput label"
              placeholder="ObInput placeholder"
              :is-valid="false"
      ></ob-input>
      <ob-input
              label="ObInput label"
              placeholder="ObInput placeholder"
              clear-icon="clear"
      ></ob-input>
    </single-pane>

    <single-pane capt="ObRadio">
      <ob-radio
              label="ObRadio 1"
              :disabled="false"
              value-input="1"
              v-model="radioValue"
      ></ob-radio>
      <ob-radio
              label="ObRadio 2"
              :disabled="false"
              value-input="2"
              v-model="radioValue"
      ></ob-radio>
      <ob-radio
              label="ObRadio 3"
              :disabled="true"
              value-input="3"
              v-model="radioValue"
      ></ob-radio>
    </single-pane>

    <single-pane capt="ObSelect">
      <ob-select
              :items="dataSelect"
              display-exp="title"
              value-exp="code"
              :disabled="false"
              placeholder="default"
      ></ob-select>
      <ob-select
              :items="dataSelect"
              display-exp="title"
              value-exp="code"
              :disabled="false"
              placeholder="with autocomplete"
              :is-auto-complete="true"
      ></ob-select>
      <ob-select
              :items="dataSelect"
              display-exp="title"
              value-exp="code"
              :disabled="false"
              placeholder="Multiselect"
              :is-multiselect="true"
      ></ob-select>
      <ob-select
              :items="dataSelect"
              display-exp="title"
              value-exp="code"
              placeholder="disabled"
              :disabled="true"
      ></ob-select>
      <ob-select
              :items="dataSelect"
              display-exp="title"
              value-exp="code"
              placeholder="Invalid"
              :invalid="true"
      ></ob-select>
      <ob-select
              :items="dataSelect"
              v-model="selectCodeValue"
              display-exp="title"
              value-exp="code"
              placeholder="dropdown"
              :is-dropdown="true"
      ></ob-select>
      <div>
        value = {{selectCodeValue}}
      </div>
    </single-pane>

    <single-pane capt="ObInlineSelect">
      <ob-inline-select
              :items="dataSelect"
              v-model="selectUuidValue"
      ></ob-inline-select>
      code = {{selectUuidValue}}
    </single-pane>

    <single-pane capt="ObDatePicker">
      <ob-date-picker
              label="ObDatePicker"
      ></ob-date-picker>
      <ob-date-picker
              label="ObDatePicker holidays"
              :allow-holidays="true"
      ></ob-date-picker>
      <ob-date-picker
              label="ObDatePicker week-ends"
              :allow-weekends="true"
      ></ob-date-picker>
      <ob-date-picker
              label="ObDatePicker All"
              :allow-all="true"
              format="dd/MM/yyyy"
      ></ob-date-picker>
      <ob-date-picker
              label="ObDatePicker Block All"
              :block-all="true"
              format="dd/MM/yyyy"
      ></ob-date-picker>
    </single-pane>

    <single-pane capt="ObSwitcherCheckbox">
      <ob-switcher-checkbox
              :label="'ob switcher checkbox'"
              v-model="switchBoxValue"
      />
      <ob-switcher-checkbox
              :label="'ob switcher checkbox disabled'"
              :disabled="true"
      />
      <ob-switcher-checkbox
              :label="'ob switcher checkbox readonly'"
              :readonly="true"
      />
      <ob-switcher-checkbox
              :label="'ob switcher checkbox dark'"
              :dark="true"
      />
    </single-pane>

    <single-pane capt="ObCheckbox">
      <ob-checkbox
              :label="'ob switcher checkbox'"
              v-model="checkBoxValue"
      />
      <ob-checkbox
              :label="'ob switcher checkbox disabled'"
              :disabled="true"
      />
      <ob-checkbox
              :label="'ob switcher checkbox readonly'"
              :readonly="true"
      />
      <ob-checkbox
              :label="'ob switcher checkbox required'"
              :required="true"
      />
    </single-pane>

    <single-pane capt="ObStepper">
      <ob-stepper
              :label="`Кол-во`"
              v-model.number="stepperValue"
              :disabled="false"
              placeholder="ObStepper"
      ></ob-stepper>
      <ob-stepper
              :label="`Кол-во disabled`"
              v-model.number="stepperValueDisabled"
              :disabled="true"
              placeholder="ObStepper"
      ></ob-stepper>
      <ob-stepper
              :label="`Кол-во > 0`"
              v-model.number="stepperValuePositive"
              :disabled="false"
              :allow-negatives="false"
              placeholder="ObStepper"
      ></ob-stepper>
      <ob-stepper
              :label="`Кол-во +/- 10`"
              v-model.number="stepperValueBy10"
              :disabled="false"
              :step="10"
              placeholder="ObStepper"
      ></ob-stepper>
      <ob-stepper
              :label="`Кол-во > 10`"
              v-model.number="stepperValueM10"
              :disabled="false"
              :minValue="10"
              placeholder="ObStepper"
      ></ob-stepper>
      <ob-stepper
              :label="`Кол-во readonly`"
              v-model.number="stepperValuereadOnly"
              :readonly="true"
              placeholder="ObStepper"
      ></ob-stepper>
    </single-pane>

    <single-pane capt="ObAddressInput">
      <ObAddressInput
              v-model="addressValue"
              label="ObAddressInput label"
              placeholder="ObAddressInput placeholder"
              :data-source="dataAddress"
              @on-change-address="onChangeModalAddress"
      />
    </single-pane>

    <single-pane capt="ObButton">
      <ob-button
              label="ObButton Primary"
              type="primary"
      />
      <ob-button
              label="ObButton flat"
              type="flat"
      />
      <ob-button
              label="ObButton Primary mini"
              type="primary"
              :mini="true"
      />
      <ob-button
              label="ObButton flat mini"
              type="flat"
              :mini="true"
      />
      <ob-button
              label="ObButton Primary danger"
              type="primary"
              :danger="true"
      />
      <ob-button
              label="ObButton flat danger flat"
              type="flat"
              :danger="true"
      />
      <ob-button
              label="ObButton Primary disabled"
              type="primary"
              :disabled="true"
      />
      <ob-button
              label="ObButton flat disabled flat"
              type="flat"
              :disabled="true"
      />
      <ob-button
              label="ObButton flat "
              :tooltip="'Tooltip for button'"
      />

    </single-pane>

    <single-pane capt="obUpload">
      <ob-uploader
              label="ObUploader"
              icon="excel"
              @uploadFiles="onUploadFiles($event, link.docTypeUuid)"
              @removeFile="onRemoveFile"
      />
      <ob-uploader
              label="ObUploader multiple"
              icon="excel"
              :multiple="true"
              @uploadFiles="onUploadFiles($event, link.docTypeUuid)"
              @removeFile="onRemoveFile"
      />
    </single-pane>

    <single-pane capt="ObBreadcrumbs">
      <ob-breadcrumbs
              :data="[
              {title: 'common-components'},
              {title: 'obComponents'},
              {title: 'obBreadcrumbs'},
              ]"
      >
      </ob-breadcrumbs>
    </single-pane>

    <single-pane capt="ObTooltip">
      <div style="display: inline-block; position: relative;">
        <ObTooltip
                position="top"
                :visible-arrow="false"
        >
          <div slot="content">
            <div align="center" v-html="'topTooltipText'"/>
          </div>
          <span>I have tooltip from top, hover me!</span>
        </ObTooltip>
      </div>
      <div style="display: inline-block; position: relative;">
        <ObTooltip
                position="bottom"
                :visible-arrow="false"
        >
          <div slot="content">
            <div align="center" v-html="'bottomTooltipText'"/>
          </div>
          <span>I have tooltip from bottom, hover me!</span>
        </ObTooltip>
      </div>
    </single-pane>

    <single-pane capt="ObTabs">
      <ObTabs>
        <ObTabsPane title="Tab#1" :is-selected="true">
          <div class="form-content">
            content#1
          </div>
        </ObTabsPane>
        <ObTabsPane title="Tab#2">
          <div class="form-content">
            content#2
          </div>
        </ObTabsPane>
        <ObTabsPane title="Tab#3">
          <div class="form-content">
            content#3
          </div>
        </ObTabsPane>
      </ObTabs>

      <ObTabs
              :items="dataSelect"
              v-model="selectedTab"
      >
      </ObTabs>
      selectedTab = {{selectedTab}}
    </single-pane>

    <single-pane capt="ObCard">
      <ob-card
        title="ObCard"
        date="20.11.2019"
        time="15:45"
        location="location text"
        locationLabel="location label"
        locationDoc="locationDoc text"
        locationDocLabel="locationDoc label"
        :companies="[
          { name: 'Company1', count: 10 },
          { name: 'Company2', count: 50 },
          { name: 'Company3', count: 40 },
        ]"
      ></ob-card>
      <ob-card
        title="ObCard"
        date="21.11.2019"
        time="16:45"
        localtionLabel="location label"
        location="location text"
        locationDoc="locationDoc text"
        locationDocLabel="locationDoc label"
      ></ob-card>
    </single-pane>

    <single-pane capt="ObInfoPanel">
      <ob-info-panel
              :info="infoPanelData"
      />
    </single-pane>

    <single-pane capt="ObForm">
      <ob-form
              :form-model="formModel"
              :form-data="formData"
              @submit="onSubmitHandler"
              @close="onCloseHandler"
      >
        <ob-input
                :label="`Наименование`"
                v-model="formData.name"
                :placeholder="`Введите название`"
                property="name"
        ></ob-input>
        <ob-input
                :label="`Вес, кг`"
                v-model="formData.weight"
                :placeholder="`Введите вес`"
                property="weight"
        ></ob-input>
      </ob-form>
    </single-pane>

  </div>
</template>

<script>
  /* eslint-disable */
    import dataGridList from "./data/data-grid"
    import dataSelectList from "./data/data-select"
    import dataAddressList from "./data/data-address"

    import SinglePane from "common-components/src/obComponents/obSinglePanels"
    import TwoPanes from "common-components/src/obComponents/obTwoPanels"
    import ObModal from 'common-components/src/obComponents/obModal'
    import ObTextarea from 'common-components/src/obComponents/obTextarea'
    import ObInput from 'common-components/src/obComponents/obInput'
    import ObRadio from 'common-components/src/obComponents/obRadio'
    import ObSelect from 'common-components/src/obComponents/obSelect'
    import ObUploader from 'common-components/src/obComponents/obUploader'
    import ObTooltip from 'common-components/src/obComponents/obTooltip'
    import ObTabs from 'common-components/src/obComponents/obTabs'
    import ObTabsPane from 'common-components/src/obComponents/obTabs/ObTabsPane'
    import obTable from 'common-components/src/obComponents/obTable'
    import ObCheckbox from 'common-components/src/obComponents/obCheckbox'
    import ObSwitcherCheckbox from 'common-components/src/obComponents/obSwitcherCheckbox'
    import ObInlineSelect from 'common-components/src/obComponents/obInlineSelect'
    import ObDatePicker from 'common-components/src/obComponents/obDatePickerConstructor'
    import ObAddressInput from 'common-components/src/obComponents/obAddressInput'
    import ObStepper from 'common-components/src/obComponents/obStepper'
    import ObButton from 'common-components/src/obComponents/obButton'
    import ObBreadcrumbs from 'common-components/src/obComponents/obBreadcrumbs'
    import ObCard from 'common-components/src/obComponents/obCard'
    import ObInfoPanel from 'common-components/src/obComponents/obInfoPanel'
    import ObFunctionalPanel from 'common-components/src/obComponents/obFuncPanel'

    import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
    import itemMixin from '@/mixins/edit-item'
    import ObForm from 'common-components/src/obComponents/obForm'
    import { required } from "vuelidate/lib/validators";


    export default {
        name: 'AllComponents',
        components: {
            ObModal,
            SinglePane,
            TwoPanes,
            ObTextarea,
            ObInput,
            ObRadio,
            ObSelect,
            ObUploader,
            ObTooltip,
            ObTabs,
            ObTabsPane,
            obTable,
            ObCheckbox,
            ObSwitcherCheckbox,
            ObInlineSelect,
            ObDatePicker,
            ObStepper,
            ObAddressInput,
            ObButton,
            ObBreadcrumbs,
            ObCard,
            ObInfoPanel,
            ObForm,
            ObFunctionalPanel
        },
        mixins: [
            FormValidationMixin, itemMixin
        ],
        data () {
            return {
                backLinkObject: { name: 'root' },
                gridDataSource: [],
                dataSelect: [],
                selectedData: { },
                selectedRow: { },
                selectedTab: {code: 2, title: 'Красный'},
                textValue: 'Текстовое значение',
                searchValue: '',
                radioValue: 1,
                stepperValue: 15,
                stepperValueDisabled: 10,
                stepperValuePositive: 18,
                stepperValueM10: 100,
                stepperValueBy10: 30,
                stepperValuereadOnly: 50,
                switchBoxValue: true,
                checkBoxValue: true,
                selectCodeValue: 1,
                selectCodesValue: [],
                selectUuidValue: 'uuid-select-3',
                addressValue: 'address value',
                uploader: {
                    files: [],
                    isHide: false
                },
                formData: {
                    name: 'Новое имя',
                    weight: '22',
                },
                infoPanelData: {
                    panelName: 'ObPanelName',
                    panelName: 'excel',
                    panelTopRows: [
                        {label: 'label1', icon: 'icon1', value: 'value1'},
                        {label: 'label2', icon: 'icon2', value: 'value2'},
                        {label: 'label3', icon: 'icon3', value: 'value3'},
                    ]
                },
                formModel: {
                    uuid: {
                        value: null
                    },
                    name: {
                        value: '',
                        validator: {
                            required
                        }
                    },
                    weight: {
                        type: 'number',
                        value: '2',
                        validator: {
                            required
                        }
                    },
                }
            }
        },
        mounted() {
            this.loadData();
        },
        computed: {
            dataAddress() {
                return dataAddressList;
            },
            totalCount() {
                return dataGridList.length;
            },
            columns () {
                return [
                    {
                        title: 'Наименвоание',
                        field: 'name',
                        width: 310,
                    },
                    {
                        title: 'Описание',
                        field: 'description',
                    },
                    {
                        title: 'Свойство 1',
                        field: 'propertyOne',
                        width: 180,
                    },
                    {
                        title: 'Свойство 2',
                        width: 170,
                        field: 'propertyTwo',
                    },
                    {
                        title: 'Статус',
                        width: 110,
                        field: 'isActive',
                        allowSorting: false,
                        calculateCellValue(data) {
                            return !data.is_active ? 'вкл.' : 'выкл.'
                        }
                    },
                ]
            },
            columnsObTable () {
                return [
                    {
                        title: 'Наименвоание',
                        key: 'name',
                    },
                    {
                        title: 'Описание',
                        key: 'description',
                    },
                    {
                        title: 'Свойство 1',
                        key: 'propertyOne',
                        width: 180,
                    },
                    {
                        title: 'Свойство 2',
                        width: 170,
                        key: 'propertyTwo',
                    },
                    {
                        title: 'Статус',
                        width: 110,
                        key: 'status',
                    },
                ]
            }
        },
        methods: {
            loadData () {
                this.gridDataSource = dataGridList;
                this.dataSelect = dataSelectList;
            },
            openModal () {
                this.$refs.modalWindow.open();
            },
            openModalMd () {
                this.$refs.modalWindowMd.open();
            },
            onSelection (data) {
                this.selectedData = data;
                this.$refs.viewItem.open()
            },
            onSelect (data) {
                console.log('select', data);
            },
            onAdd () {
                console.log('add to data grid');
            },
            onUploadFiles(files, docTypeUuid) {
                const f = {...files[0], docTypeUuid, fileUuid: uuid.v4()};
                const index = this.uploader.files.findIndex(file => file.docTypeUuid === docTypeUuid);

                if (index >= 0) {
                    this.uploader.files[index] = f;
                } else {
                    this.uploader.files.push(f);
                }
            },
            onRemoveFile(uuid) {
                this.uploader.files = this.uploader.files.filter(file => file.uuid !== uuid);
            },
            onChangeModalAddress (address) {
                console.log(address)
            },
            onSubmitHandler () {
                let data = cloneDeep(this.formData);
                console.log(data);
            },
            onCloseHandler () {
                console.log('close form');
            }
        }
    }
</script>

<style lang="scss" scoped>
</style>
